/******************************************************************************
*
* project name:    TICHESS
* project version: 1.10
* file name:       krnlgray.h
* file version:    1.00
* initial date:    07/03/2000
* author:          Csillag Kristof (hogbog@freemailc3.hu)
* description:     this is the same as gray.h, but uses gray4lib for grayscale.
*                  On my HW2 TI-89 with Universal OS 1.10, this gives a much
*                  better result
*                  This can be used only in doors mode!
*
* Original gray.h by Zeljko Juric (see the documentation of the TI-GCC libs.)
*
*
* -----------------------------------------------------------------------------
* Revision History
* -----------------------------------------------------------------------------
*
* v1.00: 07/03/2000
*        initial version (thanx to kristof)
*
******************************************************************************/

#ifndef __KGRAY
#define __KGRAY

#ifndef DOORS
#error: To use krnlgray.h "doors.h" must be included!
#endif

#ifdef __GRAY
#error: Both "gray.h" and "krnlgray.h" must not be included!
#endif
#define __GRAY

//#ifndef __BOOL
//#define __BOOL
//enum Bool {FALSE,TRUE};
//#endif

#define __GrayOn  gray4lib__0000
#define __GrayOff gray4lib__0001
#define __gp0     gray4lib__0002
#define __gp1     gray4lib__0003

#define GrayMode(x) ((x)?__GrayOn():__GrayOff())
// GRAY_HW1, GRAY_HW2 and GRAY_ON do the same,
// gray4lib and the kernel should choose the right method to use.
// I know that Universal OS does it right.
#define GetPlane(x) ((x)?__gp1:__gp0)
#define SetPlane(x) (PortSet((x)?__gp1:__gp0,0xEF,0x7F))

enum GrayModes {GRAY_OFF,GRAY_HW1,GRAY_HW2,GRAY_ON};

int __GrayOn(void);
int __GrayOff(void);
extern void *__gp0,*__gp1;

#endif
